#include <allegro.h>
#include <winalleg.h>
#include <stdio.h>
#include <stdint.h>
#include "gba.h"

#define BUFLEN ((456<<1)*3)
signed short soundbuf[BUFLEN<<2];
void addsoundbuffer();
int soundbufpos=0;

unsigned char snda,sndb;

int soundacount,soundawp,soundarp;
int soundbcount,soundbwp,soundbrp;

unsigned char soundafifo[32];
unsigned char soundbfifo[32];

FILE *soundf;

void pollsound()
{
        signed short temp;
/*        if (!soundf)
        {
                soundf=fopen("sound.pcm","wb");
                printf("Opening file!\n");
        }
//        printf("Writing to it!\n");
        putc(snda,soundf);
        putc(sndb,soundf);*/
        soundbuf[soundbufpos]=soundbuf[soundbufpos+1]=0x8000;
        temp=(snda*256);
        temp/=2;
        if (sound.ctrlh&0x0200) soundbuf[soundbufpos]+=temp;
        if (sound.ctrlh&0x0100) soundbuf[soundbufpos+1]+=temp;
        temp=(sndb*256);
        temp/=2;
        if (sound.ctrlh&0x2000) soundbuf[soundbufpos]+=temp;
        if (sound.ctrlh&0x1000) soundbuf[soundbufpos+1]+=temp;
        soundbufpos+=2;
        if (soundbufpos>=BUFLEN)
        {
                soundbufpos=0;
                addsoundbuffer();
        }
}

void clocksounda()
{
        int c;
        soundaclocks++;
        
        snda=soundafifo[soundarp];
        soundarp++;
        soundarp&=31;
        soundacount--;
        if (soundacount<0)
        {
                soundacount=0;
                soundarp--;
                soundarp&=31;
        }
        if (soundacount<=16)
        {
                sounddma(1);
/*                if (soundacount<=16)
                {
                        for (c=0;c<16;c++)
                        {
                                soundafifo[soundawp++]=0;
                                soundawp&=31;
                        }
                        printf("Sound awp %i\n",soundawp);
                        soundawp&=31;
                }*/
        }
}

void clocksoundb()
{
        int c;
        soundbclocks++;

        sndb=soundbfifo[soundbrp];
        soundbrp++;
        soundbrp&=31;
        soundbcount--;
        if (soundbcount<0)
        {
                soundbcount=0;
                soundbrp--;
                soundbrp&=31;
        }
        if (soundbcount<=16)
        {
                sounddma(2);
/*                if (soundbcount<=16)
                {
                        for (c=0;c<16;c++)
                        {
                                soundbfifo[soundbwp++]=0;
                                soundbwp&=31;
                        }
                        printf("Sound bwp %i\n",soundawp);
                        soundbwp&=31;
                }*/
        }
}

void resetsounda()
{
        soundacount=soundawp=soundarp=0;
}

void resetsoundb()
{
        soundbcount=soundbwp=soundbrp=0;
}

void writesounda(unsigned char v)
{
        if (soundacount>=32) return;
        soundafifo[soundawp++]=v;
//        printf("AWP %i\n",soundbwp);
        soundawp&=31;
        soundacount++;
}

void writesoundb(unsigned char v)
{
        if (soundbcount>=32) return;
        soundbfifo[soundbwp++]=v;
//        printf("BWP %i\n",soundbwp);
        soundbwp&=31;
        soundbcount++;
}

int infocus=1;
int soundon=1;
int soundthreadon=0,quitsoundthread=0;
void updatesoundbuffer();

void soundthread(PVOID pvoid)
{
        soundthreadon=1;
        while (!quitsoundthread)
        {
                if (infocus && soundon) updatesoundbuffer();
                else                    sleep(1);
        }
        soundthreadon=0;
}

AUDIOSTREAM *as;
void initsound()
{
        if (!soundon) return;
        inital();
        #if 0
        set_volume_per_voice(0);
        install_sound(/*DIGI_AUTODETECT*/DIGI_DIRECTAMX(0),MIDI_NONE,0);
        set_volume_per_voice(0);
        as=play_audio_stream(BUFLEN>>1,16,1,27360,255,128);
        _beginthread(soundthread,0,NULL);
        #endif
}

int bufpos=0;
unsigned short p2[BUFLEN];

int bufqueuestart=0,bufqueueend=0,bufqueuelen=0;
unsigned short soundbufferqueue[8][BUFLEN];

void addsoundbuffer()
{
        givealbuffer(soundbuf);
        return;
        if (bufqueuelen==4)
        {
                bufqueueend--;
                bufqueuelen--;
        }
        memcpy(soundbufferqueue[bufqueueend&3],soundbuf,BUFLEN*2);
        bufqueueend++;
        bufqueuelen++;
}
int quitsoundthread;
void updatesoundbuffer()
{
        unsigned short *p=NULL;
        int c;
        if (!soundon) return;
        while (!bufqueuelen)
        {
                sleep(1);
                if (quitsoundthread) return;
        }
        while (!p)
        {
                sleep(1);
                p=get_audio_stream_buffer(as);
        }
        for (c=0;c<BUFLEN;c++)
            p[c]=p2[c]=soundbufferqueue[bufqueuestart&3][c];
        free_audio_stream_buffer(as);
        bufqueuestart++;
        bufqueuelen--;
}

void skipsoundbuffer()
{
        if (!soundon) return;
        bufpos+=BUFLEN;
        if (bufpos>=(BUFLEN<<2)) bufpos=0;
//        printf("SKIP : bufpos %i adlibpos %i soundbufpos %i\n",bufpos,adlibpos,soundbufpos);
}
